package com.woolha.hibernate.repository;

import com.woolha.hibernate.model.Category;
import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

public interface CategoryRepository extends JpaRepository<Category, UUID> {

  @Query("SELECT c FROM Category c JOIN FETCH subCategories")
  List<Category> findAllWithSubCategories();

  @Query("SELECT c FROM Category c JOIN FETCH products")
  List<Category> findAllWithProducts();

  @Query("SELECT c FROM Category c WHERE id = :id")
  Optional<Category> findByIdCustom(@Param("id") UUID id);

  @Query(value = "SELECT * FROM categories c WHERE id = :id", nativeQuery = true)
  Optional<Category> findByIdNative(UUID id);
}
