package com.woolha.hibernate.service;

import com.woolha.hibernate.model.Category;
import com.woolha.hibernate.repository.CategoryRepository;
import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.stereotype.Service;

@Service
public class CategoryService {

  private final CategoryRepository categoryRepository;

  public CategoryService(CategoryRepository categoryRepository) {
    this.categoryRepository = categoryRepository;
  }

  public void getCategories() {
    Optional<Category> categoryOptional = this.categoryRepository.findById(UUID.fromString("b81cdd09-6aee-483f-93de-4a5854ff7bdb"));
    Optional<Category> categoryOptional2 = this.categoryRepository.findByIdCustom(UUID.fromString("b81cdd09-6aee-483f-93de-4a5854ff7bdb"));
    List<Category> categories = this.categoryRepository.findAll();
    List<Category> categoriesWithSubCategories = this.categoryRepository.findAllWithSubCategories();
    List<Category> categoriesWithProducts = this.categoryRepository.findAllWithProducts();

    // @Where criteria not used with native query
    // this.categoryRepository.findByIdNative(UUID.fromString("b81cdd09-6aee-483f-93de-4a5854ff7bdb"))
  }
}
