CREATE TABLE IF NOT EXISTS public."categories"
(
  id            uuid    NOT NULL,
  name          text    NOT NULL,
  is_deleted    bool    NOT NULL,
  CONSTRAINT "pk_categories" PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS public."sub_categories"
(
  id            uuid    NOT NULL,
  name          text    NOT NULL,
  is_active     bool    NOT NULL,
  category_id   uuid    NOT NULL,
  CONSTRAINT "pk_sub_categories" PRIMARY KEY (id),
  CONSTRAINT "fk_sub_categories_category_id" FOREIGN KEY(category_id) REFERENCES categories(id)
);

CREATE TABLE IF NOT EXISTS public."category_keywords"(
  category_id   uuid    NOT NULL,
  keyword       text    NOT NULL,
  CONSTRAINT "fk_category_keywords_category_id" FOREIGN KEY(category_id) REFERENCES categories(id)
);

CREATE TABLE IF NOT EXISTS public."products"(
  id            uuid    NOT NULL,
  name          text    NOT NULL,
  is_shown      bool    NOT NULL,
  CONSTRAINT "pk_products" PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS public."product_categories"(
  products_id   uuid    NOT NULL,
  categories_id uuid    NOT NULL,
  is_active     bool    NOT NULL,
  CONSTRAINT "fk_product_categories_product_id" FOREIGN KEY(product_id) REFERENCES products(id),
  CONSTRAINT "fk_product_categories_category_id" FOREIGN KEY(category_id) REFERENCES categories(id)
);

INSERT INTO categories VALUES ('c3e4b3ba-be47-4b1b-9b25-11bec35d8172', 'Category A', false);
INSERT INTO sub_categories VALUES ('7a1183ed-0a1b-49b7-82f8-38b81f73fe12', 'Sub Category 1', true, 'c3e4b3ba-be47-4b1b-9b25-11bec35d8172');
INSERT INTO sub_categories VALUES ('68193945-6e75-4d06-bf79-15df2adcc4c4', 'Sub Category 2', false, 'c3e4b3ba-be47-4b1b-9b25-11bec35d8172');

INSERT INTO categories VALUES ('c3e4b3ba-be47-4b1b-9b25-11bec35d8172', 'Category B', true);

INSERT INTO category_keywords VALUES ('c3e4b3ba-be47-4b1b-9b25-11bec35d8172', 'test');
INSERT INTO category_keywords VALUES ('c3e4b3ba-be47-4b1b-9b25-11bec35d8172', '');

INSERT INTO products VALUES ('dc2b3260-4c84-4608-a000-a28679ab7984', 'Product A', true);
INSERT INTO products VALUES ('b45748e6-3ae2-4910-8eb5-42de1a6af972', 'Product B', true);
INSERT INTO products VALUES ('864cc658-5e09-4485-bc7e-74834645b550', 'Product C', false);

INSERT INTO product_categories VALUES ('dc2b3260-4c84-4608-a000-a28679ab7984', 'c3e4b3ba-be47-4b1b-9b25-11bec35d8172', true);
INSERT INTO product_categories VALUES ('b45748e6-3ae2-4910-8eb5-42de1a6af972', 'c3e4b3ba-be47-4b1b-9b25-11bec35d8172', false);
INSERT INTO product_categories VALUES ('864cc658-5e09-4485-bc7e-74834645b550', 'c3e4b3ba-be47-4b1b-9b25-11bec35d8172', true);
